from pyrogram import Client
from pyrogram import filters
import asyncio
import subprocess
from pathlib import Path
import shutil

# api_id = 
#api_hash = ""
#bot_token = ""
# app = Client(
#     "2pdf",
#     api_id=api_id, api_hash=api_hash,
#     bot_token=bot_token
# )

app = Client("2pdf")

def validDocument(mime_type):
    valid_mime_types = [
        "application/msword", # .doc
        "application/vnd.openxmlformats-officedocument.wordprocessingml.document", # .docx
        "application/vnd.ms-excel", # xls
        "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" # .xlsx
    ]
    return mime_type in valid_mime_types

async def downloadDocument(file_id, file_name):
    filepath = await (app.download_media(file_id, file_name=file_name))
    return filepath

async def convertDocument(sourceDocumentPath, sourceDocumentName):
    libreofficePath = shutil.which("libreoffice") # Find full path to the libreoffice binary
    outputDir = "output"
    Path(outputDir).mkdir(parents=True, exist_ok=True) # Ensure directory exists
    subprocess.run(args=[libreofficePath, "--headless", "--convert-to", "pdf", "--outdir", outputDir, sourceDocumentPath], check=True)
    outputDocumentPath = Path(outputDir) / Path(f"{sourceDocumentName}").with_suffix('.pdf')
    subprocess.run(args=["rm", sourceDocumentPath], check=True)
    return outputDocumentPath
    
async def uploadDocument(outputDocumentPath, chat, message):
    await app.send_document(document=outputDocumentPath, chat_id=chat, reply_to_message_id=message)
    subprocess.run(args=["rm", outputDocumentPath])

@app.on_message(filters.document) # Get all of the messages that have files in them
async def documentFetcher(client, message):
    mime_type = message.document.mime_type
    if validDocument(mime_type=mime_type) == True:
        sourceDocumentPath = await downloadDocument(message.document.file_id, message.document.file_name)
        outputDocumentPath = await convertDocument(sourceDocumentPath, message.document.file_name)
        await uploadDocument(outputDocumentPath, message.chat.id, message.id)
    else:
       return # Hopefully message will get ignored and no futher resources will be used
    
app.run()